<template>
  <Modal
    v-if="displayModal"
    :cancelAction="toggleModal"
    :okAction="restoreVersion"
  >
  {{ $t('history.modal.text') }}
  </Modal>

  <div class="rounded-md">
    <h1 class="header">{{ $t('history.text.title') }}</h1>
    <ul class="mb-3" v-for="version, index in info" :key="version.name">
      <li>
        <div class="flex flex-row justify-between">
          <p class="info-date">
            <span class="w-32">
              <span
                v-if="indexOfFirstChangeOfTheDay(index)"
                class="font-bold"
              >
                {{ localDate(version.last_modified).format('MMM, D YYYY') }}
              </span>
              <span
                v-else
                class="info-date-else"
              >
                {{ localDate(version.last_modified).format('MMM, D') }}
              </span>
            </span>
            <span class="w-20">
              {{ localDate(version.last_modified).format('HH:mm') }}
            </span>
          </p>
            
          <button
            class="ada-button-tiny"
            type="button"
            :title="$t('history.actions.titleOpen')"
          >
            <a :href="`${urlBeginning}&timestamp=${version.name.slice(21,37)}`">{{ $t('history.actions.open') }}</a>   
          </button>

          <button
            class="ada-button-tiny"
            type="button"
            id="show-modal"
            @click="askForRestoreVersion(version.name)"
            :title="$t('history.actions.titleRestore')"
          >
            <a>{{ $t('history.actions.restore') }}</a>   
          </button>
        </div>
      </li>
    </ul>
  </div>
</template>

<script>
import axios from 'axios'
import ModalProjectHistory from './ModalProjectHistory.vue'
import { adacraftStorageUrl } from '../config'
import { useStore } from '../store'
import { getProjectUrl } from '../storage'
import { getLocalDate } from '../utils'

export default {
  name: 'TheProjectHistory',
  components: {
    'Modal' : ModalProjectHistory
  },
  props: ['project', 'storageProject'],

  data () {
    return {
      info: [],
      timestamp: "",
      displayModal: false,
      versionNameToRestore: "",
    }
  },
  setup () {
    const { authentification } = useStore()
    return { authentification }
  },
  created () {
    setInterval(this.getNow, 1000);
  },
  mounted () {
    if(this.project !== undefined) {
      this.getHistory(this.project)
    }
  },
  watch: {
    project (value) {
      this.getHistory(value)
    },
  },
  methods: {
    getHistory: function (projectId) {
      axios
        .get(`${this.historyUrl}?format=json&prefix=011projects/${projectId}`)
        .then(response => {
          this.info = response.data.sort(
            // Reverse order on project timestamp. We sort on the names which
            // are like 011projects/3ac8db65/1624952929.23339, which always
            // start with the same string and end with the timestamp.
            (a, b) => (a.name < b.name) ? 1 : -1
          )
        })
    },
    restoreVersion: function () {
      const accountToken = this.authentification.netlifyUser.app_metadata.db_token
      const restoredFromTimestamp = this.versionNameToRestore.slice(21,37)
      this.toggleModal()
      axios
        .get(`${this.historyUrl}/${this.versionNameToRestore}`)
        .then(response => {
          axios
            .put(
              `${this.urlStorageProject}`,
              response.data,
              {
                headers: {
                  'Account-Token': accountToken,
                  'X-Object-Meta-Restored-From-Timestamp': restoredFromTimestamp,
                  'Source-Timestamp': response.headers['x-object-meta-source-timestamp']
                }
              }
            )
            .then( r => {
              alert("Project is successfully restored to a previous version!")
            })
            .catch(function () {
              alert('An unexpected error occurred during the upload of the restored version. Please try again later or contact the adacraft team.')
          }) 
        })
        .catch((error) => {
          alert('An unexpected error occurred during the download of the previous version. Please try again later or contact the adacraft team.')
        })
    },
    askForRestoreVersion: function (versionName) {
      this.toggleModal()
      this.versionNameToRestore = versionName
    },
    getNow: function () {
      const today = new Date();
      const date = today.getFullYear() + '-' + (today.getMonth() + 1) + '-' + today.getDate()
      const time = today.getHours() + ":" + today.getMinutes() + ":" + today.getSeconds()
      const dateTime = date + ' ' + time
      this.timestamp = dateTime
    },
    localDate: getLocalDate,
    indexOfFirstChangeOfTheDay(index) {
      const dayString = (date) => this.localDate(date).format('MMM, D YYYY')
      return (
        index === 0 || (
          dayString(this.info[index].last_modified)
          !== dayString(this.info[index - 1].last_modified)
        )
      )
    },
    toggleModal: function () {
      this.displayModal = !this.displayModal
    }
  },

  computed: {
    urlBeginning () {
      return `/studio?project=${this.project}`
    },
    urlStorageProject () {
      return getProjectUrl(this.storageProject)
    },
    historyUrl () {
      // From "https://storage.adacraft.org" to something like
      // "https://storage-history.beta.adacraft.org"
      let url = adacraftStorageUrl.replace('storage.', 'storage-history.')
      if (this.storageProject.storage === 'https://storage.adacraft.org/2') {
        // This project is stored in the second storage container. In that case
        // we want something like "https://storage2-history.beta.adacraft.org".
        url = url.replace('storage-', 'storage2-')
      }
      return url
    }
  }
}
</script>

<style lang="postcss" scoped>
.header {
  @apply mb-8;
  @apply font-bold text-xl text-center;
  @apply dark:text-gray-300;
}

.info-date {
  @apply w-56 h-4;
  @apply flex;
  @apply text-gray-700;
  @apply dark:text-gray-400;
}
.info-date-else {
  @apply text-xs text-gray-500;
  @apply dark:text-gray-400;
}
</style>